/*
 * generated by Xtext 2.29.0
 */
package org.eclipse.papyrus.robotics.xtext.datatypes.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.papyrus.robotics.xtext.datatypes.ide.contentassist.antlr.internal.InternalDTMLParser;
import org.eclipse.papyrus.robotics.xtext.datatypes.services.DTMLGrammarAccess;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class DTMLParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(DTMLGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, DTMLGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getModelAccess().getAlternatives(), "rule__Model__Alternatives");
			builder.put(grammarAccess.getDTKeyAccess().getAlternatives(), "rule__DTKey__Alternatives");
			builder.put(grammarAccess.getPropertyAccess().getAlternatives_2_1(), "rule__Property__Alternatives_2_1");
			builder.put(grammarAccess.getExpressionStringAccess().getAlternatives(), "rule__ExpressionString__Alternatives");
			builder.put(grammarAccess.getValueAccess().getAlternatives(), "rule__Value__Alternatives");
			builder.put(grammarAccess.getUnlimitedLiteralAccess().getAlternatives(), "rule__UnlimitedLiteral__Alternatives");
			builder.put(grammarAccess.getVisibilityKindAccess().getAlternatives(), "rule__VisibilityKind__Alternatives");
			builder.put(grammarAccess.getDirectionAccess().getAlternatives(), "rule__Direction__Alternatives");
			builder.put(grammarAccess.getXDataTypeAccess().getGroup(), "rule__XDataType__Group__0");
			builder.put(grammarAccess.getPropertyAccess().getGroup(), "rule__Property__Group__0");
			builder.put(grammarAccess.getPropertyAccess().getGroup_2(), "rule__Property__Group_2__0");
			builder.put(grammarAccess.getPropertyAccess().getGroup_4(), "rule__Property__Group_4__0");
			builder.put(grammarAccess.getXAssignmentAccess().getGroup(), "rule__XAssignment__Group__0");
			builder.put(grammarAccess.getXEnumerationAccess().getGroup(), "rule__XEnumeration__Group__0");
			builder.put(grammarAccess.getXEnumLiteralAccess().getGroup(), "rule__XEnumLiteral__Group__0");
			builder.put(grammarAccess.getXEnumLiteralAccess().getGroup_1(), "rule__XEnumLiteral__Group_1__0");
			builder.put(grammarAccess.getQualifiedNameAccess().getGroup(), "rule__QualifiedName__Group__0");
			builder.put(grammarAccess.getTypeRuleAccess().getGroup(), "rule__TypeRule__Group__0");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getGroup(), "rule__MultiplicityRule__Group__0");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getGroup_2(), "rule__MultiplicityRule__Group_2__0");
			builder.put(grammarAccess.getXDataTypeAccess().getNameAssignment_1(), "rule__XDataType__NameAssignment_1");
			builder.put(grammarAccess.getXDataTypeAccess().getAttributesAssignment_3(), "rule__XDataType__AttributesAssignment_3");
			builder.put(grammarAccess.getPropertyAccess().getNameAssignment_1(), "rule__Property__NameAssignment_1");
			builder.put(grammarAccess.getPropertyAccess().getTypeAssignment_2_1_0(), "rule__Property__TypeAssignment_2_1_0");
			builder.put(grammarAccess.getPropertyAccess().getTypeUndefinedAssignment_2_1_1(), "rule__Property__TypeUndefinedAssignment_2_1_1");
			builder.put(grammarAccess.getPropertyAccess().getMultiplicityAssignment_3(), "rule__Property__MultiplicityAssignment_3");
			builder.put(grammarAccess.getPropertyAccess().getValueAssignment_4_1(), "rule__Property__ValueAssignment_4_1");
			builder.put(grammarAccess.getPropertyAccess().getCommentAssignment_5(), "rule__Property__CommentAssignment_5");
			builder.put(grammarAccess.getXAssignmentAccess().getNameAssignment_0(), "rule__XAssignment__NameAssignment_0");
			builder.put(grammarAccess.getXAssignmentAccess().getExpressionAssignment_2(), "rule__XAssignment__ExpressionAssignment_2");
			builder.put(grammarAccess.getValueAccess().getStrAssignment_0(), "rule__Value__StrAssignment_0");
			builder.put(grammarAccess.getValueAccess().getIvalAssignment_1(), "rule__Value__IvalAssignment_1");
			builder.put(grammarAccess.getValueAccess().getDvalAssignment_2(), "rule__Value__DvalAssignment_2");
			builder.put(grammarAccess.getXEnumerationAccess().getNameAssignment_1(), "rule__XEnumeration__NameAssignment_1");
			builder.put(grammarAccess.getXEnumerationAccess().getLiteralsAssignment_3(), "rule__XEnumeration__LiteralsAssignment_3");
			builder.put(grammarAccess.getXEnumLiteralAccess().getNameAssignment_0(), "rule__XEnumLiteral__NameAssignment_0");
			builder.put(grammarAccess.getXEnumLiteralAccess().getValueAssignment_1_1(), "rule__XEnumLiteral__ValueAssignment_1_1");
			builder.put(grammarAccess.getXEnumLiteralAccess().getCommentAssignment_2(), "rule__XEnumLiteral__CommentAssignment_2");
			builder.put(grammarAccess.getQualifiedNameAccess().getPathAssignment_0(), "rule__QualifiedName__PathAssignment_0");
			builder.put(grammarAccess.getQualifiedNameAccess().getRemainingAssignment_2(), "rule__QualifiedName__RemainingAssignment_2");
			builder.put(grammarAccess.getTypeRuleAccess().getPathAssignment_0(), "rule__TypeRule__PathAssignment_0");
			builder.put(grammarAccess.getTypeRuleAccess().getTypeAssignment_1(), "rule__TypeRule__TypeAssignment_1");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getBoundsAssignment_1(), "rule__MultiplicityRule__BoundsAssignment_1");
			builder.put(grammarAccess.getMultiplicityRuleAccess().getBoundsAssignment_2_1(), "rule__MultiplicityRule__BoundsAssignment_2_1");
			builder.put(grammarAccess.getBoundSpecificationAccess().getValueAssignment(), "rule__BoundSpecification__ValueAssignment");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private DTMLGrammarAccess grammarAccess;

	@Override
	protected InternalDTMLParser createParser() {
		InternalDTMLParser result = new InternalDTMLParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public DTMLGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(DTMLGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
